require(e1071)
require(maxLik)
require(numDeriv)
require(msm)

#######################################################
#        Internal functions                           #
#######################################################
p.range<- function(p,eps=2.22e-15)
{  out<-p
	out[p<eps]<-eps
	out[p>(1-eps)]<- (1-eps)
    return(out)
 }    
 
get.S<- function(m) 
{ S <- t(bincombinations(m))	
  return(S)
} 


get.g<- function(g)
{ n<- length(g)
  out<- rep(0,n)
  uni<- unique(g)
  N<- length(unique(g))
  for(i in 1:N)
   {cond<- (g==uni[i])
    ind<- (1:n)[cond]
    out[ind]<-i
   }
 return(out)
}

appr.constr.mle <- function(psi,mle,J,which)
{
	# compute approximate constrained mle for psi
	# which gives the index corresponding to psi
	out <- rep(NA,length(mle))
	out[which] <- psi
	out[-which] <- as.vector(mle[-which]+solve(J[-which,-which])%*%J[-which,which]%*%(mle[which]-psi))
	out
}

